import * as React from "react";
import { DataType } from "@kie-tools/boxed-expression-component/dist/api";
import { ColumnInstance } from "react-table";
import { DmnUnitablesJsonSchemaBridge } from "./uniforms/DmnUnitablesJsonSchemaBridge";
import { BoxedExpressionOutputRule } from "@kie-tools/unitables/dist/UnitablesBoxedTypes";
import { DecisionResult } from "./DmnTypes";
interface OutputField {
    dataType: DataType;
    width?: number;
    name: string;
}
interface OutputTypesField extends OutputField {
    type: string;
}
interface OutputWithInsideProperties extends OutputTypesField {
    insideProperties: Array<OutputTypesField>;
}
declare type OutputTypesFields = OutputTypesField | OutputWithInsideProperties;
declare type OutputFields = OutputField | OutputWithInsideProperties;
declare type OutputTypesAndNormalFields = OutputTypesFields | OutputFields;
export declare function isOutputWithInsideProperties(toBeDetermined: OutputTypesAndNormalFields): toBeDetermined is OutputWithInsideProperties;
export declare function useDmnBoxedOutputs(jsonSchemaBridge: DmnUnitablesJsonSchemaBridge, results: Array<DecisionResult[] | undefined> | undefined, rowCount: number, outputColumnsCache: React.MutableRefObject<ColumnInstance[]>): {
    outputs: OutputFields[];
    outputRules: BoxedExpressionOutputRule[];
    updateOutputCellsWidth: (outputs: OutputFields[]) => void;
};
export {};
//# sourceMappingURL=DmnBoxedOutputs.d.ts.map