import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { useCallback, useEffect, useMemo, useRef, useState } from "react";
import { EmptyState, EmptyStateBody, EmptyStateIcon } from "@patternfly/react-core/dist/js/components/EmptyState";
import { ExclamationIcon } from "@patternfly/react-icons/dist/js/icons/exclamation-icon";
import { Text, TextContent } from "@patternfly/react-core/dist/js/components/Text";
import nextId from "react-id-generator";
import { BoxedExpressionProvider } from "@kie-tools/boxed-expression-component/dist/components";
import { CubeIcon } from "@patternfly/react-icons/dist/js/icons/cube-icon";
import { useDmnBoxedOutputs } from "./DmnBoxedOutputs";
import { ErrorBoundary } from "@kie-tools/form";
import { CustomTable } from "@kie-tools/unitables/dist/boxed";
export function DmnTableResults(props) {
    const outputUid = useMemo(() => nextId(), []);
    const outputErrorBoundaryRef = useRef(null);
    const outputColumnsCache = useRef([]);
    const [outputError, setOutputError] = useState(false);
    const { outputs, outputRules, updateOutputCellsWidth } = useDmnBoxedOutputs(props.jsonSchemaBridge, props.results, props.rowCount, outputColumnsCache);
    const onOutputColumnsUpdate = useCallback((columns) => {
        outputColumnsCache.current = columns;
        updateOutputCellsWidth(outputs);
    }, [outputs, updateOutputCellsWidth]);
    useEffect(() => {
        var _a;
        (_a = outputErrorBoundaryRef.current) === null || _a === void 0 ? void 0 : _a.reset();
    }, [outputs]);
    const outputEntriesLength = useMemo(() => outputRules.reduce((length, rules) => { var _a, _b; return length + ((_b = (_a = rules.outputEntries) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0); }, 0), [outputRules]);
    return (_jsx(_Fragment, { children: outputError ? (outputError) : outputEntriesLength > 0 ? (_jsx(ErrorBoundary, Object.assign({ ref: outputErrorBoundaryRef, setHasError: setOutputError, error: _jsx(OutputError, {}, void 0) }, { children: _jsx(BoxedExpressionProvider, Object.assign({ expressionDefinition: {}, isRunnerTable: true, decisionNodeId: outputUid, dataTypes: [] }, { children: _jsx(CustomTable, { name: "DMN Runner Output", i18n: props.i18n, onColumnsUpdate: onOutputColumnsUpdate, output: outputs, rules: outputRules, id: outputUid, onRowNumberUpdate: props.onRowNumberUpdate }, void 0) }), void 0) }), void 0)) : (_jsxs(EmptyState, { children: [_jsx(EmptyStateIcon, { icon: CubeIcon }, void 0), _jsx(TextContent, { children: _jsx(Text, Object.assign({ component: "h2" }, { children: "Without Responses Yet" }), void 0) }, void 0), _jsx(EmptyStateBody, { children: _jsx(TextContent, { children: "Add decision nodes and fill the input nodes!" }, void 0) }, void 0)] }, void 0)) }, void 0));
}
function OutputError() {
    return (_jsx("div", { children: _jsxs(EmptyState, { children: [_jsx(EmptyStateIcon, { icon: ExclamationIcon }, void 0), _jsx(TextContent, { children: _jsx(Text, Object.assign({ component: "h2" }, { children: "Error" }), void 0) }, void 0), _jsx(EmptyStateBody, { children: _jsx("p", { children: "An error has happened while trying to show your outputs" }, void 0) }, void 0)] }, void 0) }, void 0));
}
//# sourceMappingURL=DmnTableResults.js.map