import { NotificationSeverity } from "@kie-tools-core/notifications/dist/api";
export declare enum EvaluationStatus {
    SUCCEEDED = "SUCCEEDED",
    SKIPPED = "SKIPPED",
    FAILED = "FAILED"
}
export interface DecisionResultMessage {
    severity: NotificationSeverity;
    message: string;
    messageType: string;
    sourceId: string;
    level: string;
}
export declare type Result = boolean | number | null | object | object[] | string;
export declare type DmnSchemaProperties = {
    "x-dmn-type": string;
    type: string;
    $ref: string;
};
export interface DecisionResult {
    decisionId: string;
    decisionName: string;
    result: Result;
    messages: DecisionResultMessage[];
    evaluationStatus: EvaluationStatus;
}
//# sourceMappingURL=DmnTypes.d.ts.map