import { FEEL_CONTEXT, DAYS_AND_TIME_DURATION_FORMAT, YEARS_AND_MONTHS_DURATION_FORMAT, } from "@kie-tools/form-dmn/dist/uniforms";
import { UnitablesJsonSchemaBridge } from "@kie-tools/unitables/dist/uniforms";
export class DmnUnitablesJsonSchemaBridge extends UnitablesJsonSchemaBridge {
    getField(name) {
        const field = super.getField(name);
        if (field.format === DAYS_AND_TIME_DURATION_FORMAT) {
            field.placeholder = "P1DT5H or P2D or PT1H2M10S";
        }
        if (field.format === YEARS_AND_MONTHS_DURATION_FORMAT) {
            field.placeholder = "P1Y5M or P2Y or P1M";
        }
        if (field["x-dmn-type"] === FEEL_CONTEXT) {
            field.placeholder = `{ "x": <value> }`;
        }
        return field;
    }
    getBoxedFieldType(field) {
        var _a, _b, _c, _d;
        let extractedType = ((_a = field["x-dmn-type"]) !== null && _a !== void 0 ? _a : "").split("FEEL:").pop();
        if (((_b = extractedType === null || extractedType === void 0 ? void 0 : extractedType.length) !== null && _b !== void 0 ? _b : 0) > 1) {
            extractedType = (_d = ((_c = field["x-dmn-type"]) !== null && _c !== void 0 ? _c : "").split(":").pop()) === null || _d === void 0 ? void 0 : _d.split("}").join("").trim();
        }
        return extractedType;
    }
}
//# sourceMappingURL=DmnUnitablesJsonSchemaBridge.js.map